package demo.server.service;

import java.util.List;

import org.seasar.doma.jdbc.SelectOptions;

import com.google.gwt.user.server.rpc.RemoteServiceServlet;

import demo.client.service.EmployeeService;
import demo.server.dao.EmployeeDao;
import demo.server.dao.EmployeeDaoImpl;
import demo.shared.entity.Employee;

/**
 * The server side implementation of the RPC service.
 */
@SuppressWarnings("serial")
public class EmployeeServiceImpl extends RemoteServiceServlet implements
        EmployeeService {

    private static int LIMMIT = 6;

    public List<Employee> selectAll() {
        EmployeeDao dao = getEmployeeDao();
        return dao.selectAll();
    }

    @Override
    public List<Employee> select(int offset) {
        EmployeeDao dao = getEmployeeDao();
        SelectOptions options = SelectOptions.get().limit(LIMMIT)
                .offset(offset);
        return dao.select(options);
    }

    @Override
    public void insert(Employee employee) {
        EmployeeDao dao = getEmployeeDao();
        dao.insert(employee);
    }

    @Override
    public void delete(Employee employee) {
        EmployeeDao dao = getEmployeeDao();
        dao.delete(employee);
    }

    @Override
    public void update(Employee employee) {
        EmployeeDao dao = getEmployeeDao();
        dao.update(employee);
    }

    protected EmployeeDao getEmployeeDao() {
        return new EmployeeDaoImpl();
    }
}
